precision mediump float;

uniform sampler2D SamplerY;
uniform sampler2D SamplerUV;
uniform mat3 yuv2rgb;

varying highp vec2 texCoordVarying;

void main() {
    mediump vec3 yuv;
    lowp vec3 rgb;

    // See git history for some (now deleted) commentary on the challenges of figuring out
    // YUV -> RGB conversion.

    yuv.x = WA_TEX_Y(texture2D(SamplerY, texCoordVarying)) - 16.0/255.0;
    yuv.yz = WA_TEX_UV(texture2D(SamplerUV, texCoordVarying)) - vec2(0.5, 0.5);
    rgb = yuv2rgb * yuv.xyz;

    gl_FragColor = vec4(rgb, 1);
}

